//Reloj hecho a vase de interupciones
// SETA43
// Programa hecho por JUAN GALAZ
//02/03/2013
#include <avr/io.h>
#include <avr/interrupt.h>

#include <LiquidCrystal.h>

#include <Wire.h>
#include <EEPROM.h>

#define debug 0

byte LedPin=8;
byte LedPin2=11;
byte e1Pin=9;
byte e2Pin=10;

byte horas,minutos,segundos;
byte Ahoras,Aminutos,Asegundos;
byte bandera=1;
int dormir;
byte alarma;  //0-1 Alarma ON, 3-Alarma OFF

char VARI[20];
int z,zz;
byte bz;

unsigned char frequencyH = 0;
unsigned char frequencyL = 0;

unsigned int frequencyB;
double frequency = 0;
byte bfrequency;
double gfrequency;
byte rdato[7];
byte signal;
int reading;


char *menu[]={" ","SLEEP","MODE_MEMO","MODE_SCAN","MODE_DIAL","ALARM","MEMORY","LEVEL-SCAN","TIME"};
char *menu1[]={" ","DIAL","MEMORY ","SCAN"};

byte bmemory;
byte memo;
byte mymenu;
byte mymode;
byte mylevel;
byte bandera2;


LiquidCrystal lcd(2,3,4,5,6,7);


void setup(){
  Serial.begin(9600);
  lcd.begin(16, 2);
  Wire.begin();
  pinMode(LedPin, OUTPUT);
  pinMode(LedPin2, OUTPUT);
  pinMode(e1Pin, INPUT);
  pinMode(e2Pin, INPUT);
  cli();
  TCCR1A=0;
  TCCR1B=0;
  OCR1A=15624;
  TCCR1B |= (1<<WGM12);
  TCCR1B |= (1<<CS10);
  TCCR1B |= (1<<CS12);
  TIMSK1=(1<<OCIE1A);
  sei();
  mymenu=0;
  mymode=2;  //si queremos que cuando se encienda la radio este en modo Dial poner 1
  mylevel=2;
  dormir=0;
  alarma=3;
  memo=0;
  bandera2=0;
  
  bfrequency = EEPROM.read(0);
  frequency=875+bfrequency;               
  frequency/=10;
  setFrequency();  
  
}

void loop()
{    

   if(!digitalRead(e1Pin))
        {
         mymenu++;         
         if(mymenu>8)mymenu=0;
         lcd.clear();
         lcd.setCursor(0,0);
         lcd.print(menu[mymenu]);
         if(bandera2==1)mymenu=0;
         bandera2=0;
         delay(100);
         while(!digitalRead(e1Pin));
        }         
       
  switch(mymenu)
    {      
      case 0:      
        switch(mymode)
           {
            case 1:
                reading = analogRead(0);  
//               frequency = ((double)reading * (108.0 - 87.5)) / 1024.0 + 87.5;
                 frequency = ((double)reading * 20.5) / 1024.0 + 87.5;
                frequency = ((int)(frequency * 10)) / 10.0;
                
                setFrequency();
                if(!digitalRead(e2Pin))
                     {
                       if(debug)Serial.println(bfrequency);
                       while(!digitalRead(e2Pin));
                     } 
                
            break; 
            case 2:
                if(!digitalRead(e2Pin))
                     {
                       memo++;
                       if(memo>19)memo=0;                       
                       bfrequency = EEPROM.read(memo);
                       frequency=875+bfrequency;               
                       frequency/=10;
                       setFrequency();               
                       while(!digitalRead(e2Pin));
                     }                         
            break; 
            case 3:
                if(!digitalRead(e2Pin))
                     {
                      menuScan();
                      while(!digitalRead(e2Pin));                                            
                     }              
            break;   
           }
          
        lcd.setCursor(0,0);
        lcd.print(frequency);
        lcd.print(" MHz ");
                
        if(bandera)
          {
           bandera=0;
           if(alarma==1) { dormir=10; alarma=0;}
           
           if(dormir<1)
               {
                digitalWrite(LedPin2,LOW);
                lcd.setCursor(12,0);
                lcd.print("OFF ");
               }
             else
              {               
                if(!digitalRead(LedPin2))
                   {
                    digitalWrite(LedPin2,HIGH);
                    delay(500);
                    setFrequency();
                    delay(500);
                    setFrequency();
                   }
                getDatos();   
                signal=rdato[4] >> 4;
                lcd.setCursor(12,0);
                if(segundos & 2)
                  {
                   lcd.print("Pw");   
                   lcd.print(signal);
                   lcd.print("  "); 
                   }
                 else
                   {
                    if(rdato[3] & 128)
                        lcd.print("STE ");
                     else
                        lcd.print("MONO");
                   }     
              } 
               
           lcd.setCursor(0,1);
           lcd.print(menu1[mymode]);
           if(mymode==2)
             {
               lcd.print(memo);
               lcd.print("  ");
             }
           
           lcd.setCursor(9, 1);
           if(alarma==3)
               lcd.print(" ");
              else
               lcd.print("A");             
           
           digitalWrite(LedPin, !digitalRead(LedPin));    
           sprintf(VARI,"%02d:%02d",horas,minutos); 
           if(debug)Serial.println(VARI);
           lcd.setCursor(11, 1);
           lcd.print(VARI);   
  
                     
           }      
      break;         
      case 1:
         lcd.setCursor(0,1);
         lcd.print(dormir);
         lcd.print(" Minutos ");
         if(!digitalRead(e2Pin))
             {
               if(dormir>11)
                   dormir-=10;
                  else
                   dormir--;
               if(dormir<0)dormir=60;
               bandera2=1;
               while(!digitalRead(e2Pin));
             }         
      break;      
      case 2:
         if(!digitalRead(e2Pin))
             {
               mymode=2;
               mymenu=0;
               bfrequency = EEPROM.read(memo);                       
               frequency=875+bfrequency;
               frequency/=10;
               setFrequency();              
               while(!digitalRead(e2Pin));
             }          
      break;      
      case 3:         
         if(!digitalRead(e2Pin))
             {
               mymode=3;
               mymenu=0;
               while(!digitalRead(e2Pin));
             }          
      break; 
      case 4:
         if(!digitalRead(e2Pin))
             {
               mymode=1;
               mymenu=0;
               while(!digitalRead(e2Pin));               
             }                   
      break;
   
    case 5:
         sprintf(VARI,"%02d:%02d",Ahoras,Aminutos);          
         lcd.setCursor(0, 1);
         lcd.print(VARI); 
          if(!digitalRead(e2Pin))
             {             
              menuAlarm();
              mymenu=0;
              lcd.clear();
               while(!digitalRead(e2Pin));
             }       
      break;  
      case 6:
          if(!digitalRead(e2Pin))
                     {
                      menuMemory();
                      while(!digitalRead(e2Pin));
                      lcd.clear();
                      mymenu=0;                      
                     }        
      break;
      case 7:
         lcd.setCursor(0,1);
         lcd.print(mylevel);    
         if(!digitalRead(e2Pin))
             {                          
               mylevel++; if(mylevel>3)mylevel=1; 
               bandera2=1;              
               while(!digitalRead(e2Pin));
             }          
      break;    
      case 8:
          sprintf(VARI,"%02d:%02d",horas,minutos);          
          lcd.setCursor(0, 1);
          lcd.print(VARI); 
          if(!digitalRead(e2Pin))
             {              
              menuTime();
              mymenu=0;
              lcd.clear();
              while(!digitalRead(e2Pin));
             }       
      break;     
      
    }

}

void calculo()
{
     bfrequency=frequency*10-875;
     frequencyB = 4 * (frequency * 1000000 + 225000) / 32768;
     frequencyH = frequencyB >> 8;
     frequencyL = frequencyB & 0XFF; 
}

void menuMemory()
{
     lcd.setCursor(0,1);
     lcd.print(memo); 
     lcd.setCursor(8,0);
     lcd.print(frequency);
     delay(500);
     while(1)
      {
       if(!digitalRead(e2Pin))
                     {
                       memo++;
                       if(memo>19)memo=0;
                       lcd.setCursor(0,1);
                       lcd.print(memo);
                       lcd.print("  ");                       
                       while(!digitalRead(e2Pin));
                     }  
       if(!digitalRead(e1Pin))
                     {
                       if(debug)Serial.println(memo);
                       if(debug)Serial.println(bfrequency);
                       EEPROM.write(memo,bfrequency );
                       while(!digitalRead(e1Pin));
                       return;
                     }        
      }
}

void menuScan()
{                     
                      delay(100);
                      frequency+=0.1;
                      if(frequency>108)frequency=88.5;
                      calculo();
                      bz=mylevel<<5;
                      bz=bz | 0x90;
                      Wire.beginTransmission(0x60);
                      Wire.write(frequencyH+0x40);
                      Wire.write(frequencyL);
                      Wire.write(bz);
                      Wire.write(0x1F);
                      Wire.write((byte)0x00);       
                      Wire.endTransmission();
                      delay(100);                                                                         
                      getDatos();
                      gfrequency=(((rdato[1]&0x3F)<<8)+rdato[2])*32768/4-225000;
                      if(debug)for (int i=1; i<6; i++) Serial.println(rdato[i]);
                      frequency=gfrequency/10000;
                      if(debug)Serial.println(frequency);
                      z=frequency;
                      zz=z+5;     z/=10;   zz/=10;
                      if(debug)Serial.println(z);
                      if(debug)Serial.println(zz);
                      if(zz>z)
                         frequency=zz;
                        else
                         frequency=z;
                      frequency/=10;
                      if(debug)Serial.println(frequency);
                      calculo();
                      delay(100);
                      Wire.beginTransmission(0x60);
                      Wire.write(frequencyH);
                      Wire.write(frequencyL);
                      Wire.write(0xB0);
                      Wire.write(0x1F);
                      Wire.write((byte)0x00);       
                      Wire.endTransmission();
                      delay(100);              
}

void menuAlarm()
{
   while(1)
    {
     lcd.setCursor(0,1);
     lcd.print("Alarm   ");
     if(alarma==3)
         lcd.print("OFF");
        else
         lcd.print("ON ");
     if(!digitalRead(e2Pin))
             {
              if(alarma==3)
                  alarma=0;
                else
                  alarma=3;                              
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
  
   while(1)
    {
     lcd.setCursor(0,1);
     lcd.print("Hours   ");
     lcd.print(Ahoras);
     lcd.print("  "); 
     if(!digitalRead(e2Pin))
             {
              Ahoras++;
              if(Ahoras==24)Ahoras=0; 
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
  while(1)
    {
      lcd.setCursor(0,1);
      lcd.print("Minutes ");
      lcd.print(Aminutos);
      lcd.print("  "); 
      if(!digitalRead(e2Pin))
             {
              Aminutos++;
              Asegundos=0;
              if(Aminutos==60)Aminutos=0;
              while(!digitalRead(e2Pin));
             }
      if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }    
}  

void menuTime()
{
  while(1)
    {
     lcd.setCursor(0,1);
     lcd.print("Hours   ");
     lcd.print(horas);
     lcd.print("  "); 
     if(!digitalRead(e2Pin))
             {
              horas++;
              if(horas==24)horas=0; 
              while(!digitalRead(e2Pin));
             }
     if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }
  while(1)
    {
      lcd.setCursor(0,1);
      lcd.print("Minutes ");
      lcd.print(minutos);
      lcd.print("  "); 
      if(!digitalRead(e2Pin))
             {
              minutos++;
              segundos=0;
              if(minutos==60)minutos=0;
              while(!digitalRead(e2Pin));
             }
      if(!digitalRead(e1Pin))
            {
              while(!digitalRead(e1Pin));
              break;         
            }  
    }    
}


void setFrequency()
{
calculo();
//delay(100);
Wire.beginTransmission(0x60);
Wire.write(frequencyH);
Wire.write(frequencyL);
Wire.write(0xB0);
Wire.write(0x10);
Wire.write((byte)0x00);
Wire.endTransmission();
//delay(100);
} 

void getDatos()
{
  Wire.requestFrom(0x60,5); //reading TEA5767
  if (Wire.available()) 
    {
      for (int i=1; i<6; i++) rdato[i]= Wire.read();
    }
}

ISR(TIMER1_COMPA_vect)
{
  bandera=1;
  segundos++;
  if(segundos>59)
    {
     segundos=0;
     minutos++;
     if(dormir>0)dormir--;
     if(minutos>59)
         {
          minutos=0;
          horas++;
            if(horas>23)
              {               
               segundos=0;
               minutos=0;
               horas=0;
              }
         } 
    }
  if(alarma==0 && segundos==0 && minutos==Aminutos && horas==Ahoras)alarma=1;      
}
